package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.TSSDTask;
import com.sa.ibiz.demo.demo.service.TSSDTaskService;
import com.sa.ibiz.demo.demo.service.dto.TSSDTaskSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/tssdtask")
public class TSSDTaskResource
{
	@Autowired
	private TSSDTaskService service;


	@PostMapping(value = "/update")
	public ResponseEntity<TSSDTask> update(@Validated @RequestBody TSSDTask data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度任务项[update]操作发生错误","TSSDTask",data.getTssdtaskid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<TSSDTask> create(@Validated @RequestBody TSSDTask data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度任务项[create]操作发生错误","TSSDTask",data.getTssdtaskid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<TSSDTask> getDraft(@Validated @RequestBody TSSDTask data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度任务项[getDraft]操作发生错误","TSSDTask","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<TSSDTask> checkKey(@Validated @RequestBody TSSDTask data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度任务项[checkKey]操作发生错误","TSSDTask",data.getTssdtaskid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<TSSDTask> remove(@Validated @RequestBody TSSDTask data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度任务项[remove]操作发生错误","TSSDTask",data.getTssdtaskid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<TSSDTask> get(@Validated @PathVariable String id){
		TSSDTask data=new TSSDTask();
		data.setTssdtaskid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("任务调度任务项[get]操作发生错误","TSSDTask",id.toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<TSSDTask>> searchDefaultPage(@Validated @RequestBody TSSDTaskSearchFilter filter){
		Page<TSSDTask> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<TSSDTask>> listDefault(@Validated @RequestBody TSSDTaskSearchFilter filter){
		List<TSSDTask> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
